/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ExtractionDebugResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExtractionDebugResponse{}

// ExtractionDebugResponse struct for ExtractionDebugResponse
type ExtractionDebugResponse struct {
	Status   *string         `json:"status,omitempty"`
	Message  *string         `json:"message,omitempty"`
	Started  NullableFloat32 `json:"started,omitempty"`
	Ended    NullableFloat32 `json:"ended,omitempty"`
	Duration NullableString  `json:"duration,omitempty"`
	MemoryMb NullableInt32   `json:"memory_mb,omitempty"`
	Logs     []interface{}   `json:"logs,omitempty"`
	RowCount *int32          `json:"row_count,omitempty"`
	Blob     NullableString  `json:"blob,omitempty"`
}

// NewExtractionDebugResponse instantiates a new ExtractionDebugResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExtractionDebugResponse() *ExtractionDebugResponse {
	this := ExtractionDebugResponse{}
	return &this
}

// NewExtractionDebugResponseWithDefaults instantiates a new ExtractionDebugResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExtractionDebugResponseWithDefaults() *ExtractionDebugResponse {
	this := ExtractionDebugResponse{}
	return &this
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *ExtractionDebugResponse) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionDebugResponse) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *ExtractionDebugResponse) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *ExtractionDebugResponse) SetStatus(v string) {
	o.Status = &v
}

// GetMessage returns the Message field value if set, zero value otherwise.
func (o *ExtractionDebugResponse) GetMessage() string {
	if o == nil || IsNil(o.Message) {
		var ret string
		return ret
	}
	return *o.Message
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionDebugResponse) GetMessageOk() (*string, bool) {
	if o == nil || IsNil(o.Message) {
		return nil, false
	}
	return o.Message, true
}

// HasMessage returns a boolean if a field has been set.
func (o *ExtractionDebugResponse) HasMessage() bool {
	if o != nil && !IsNil(o.Message) {
		return true
	}

	return false
}

// SetMessage gets a reference to the given string and assigns it to the Message field.
func (o *ExtractionDebugResponse) SetMessage(v string) {
	o.Message = &v
}

// GetStarted returns the Started field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionDebugResponse) GetStarted() float32 {
	if o == nil || IsNil(o.Started.Get()) {
		var ret float32
		return ret
	}
	return *o.Started.Get()
}

// GetStartedOk returns a tuple with the Started field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionDebugResponse) GetStartedOk() (*float32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Started.Get(), o.Started.IsSet()
}

// HasStarted returns a boolean if a field has been set.
func (o *ExtractionDebugResponse) HasStarted() bool {
	if o != nil && o.Started.IsSet() {
		return true
	}

	return false
}

// SetStarted gets a reference to the given NullableFloat32 and assigns it to the Started field.
func (o *ExtractionDebugResponse) SetStarted(v float32) {
	o.Started.Set(&v)
}

// SetStartedNil sets the value for Started to be an explicit nil
func (o *ExtractionDebugResponse) SetStartedNil() {
	o.Started.Set(nil)
}

// UnsetStarted ensures that no value is present for Started, not even an explicit nil
func (o *ExtractionDebugResponse) UnsetStarted() {
	o.Started.Unset()
}

// GetEnded returns the Ended field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionDebugResponse) GetEnded() float32 {
	if o == nil || IsNil(o.Ended.Get()) {
		var ret float32
		return ret
	}
	return *o.Ended.Get()
}

// GetEndedOk returns a tuple with the Ended field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionDebugResponse) GetEndedOk() (*float32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Ended.Get(), o.Ended.IsSet()
}

// HasEnded returns a boolean if a field has been set.
func (o *ExtractionDebugResponse) HasEnded() bool {
	if o != nil && o.Ended.IsSet() {
		return true
	}

	return false
}

// SetEnded gets a reference to the given NullableFloat32 and assigns it to the Ended field.
func (o *ExtractionDebugResponse) SetEnded(v float32) {
	o.Ended.Set(&v)
}

// SetEndedNil sets the value for Ended to be an explicit nil
func (o *ExtractionDebugResponse) SetEndedNil() {
	o.Ended.Set(nil)
}

// UnsetEnded ensures that no value is present for Ended, not even an explicit nil
func (o *ExtractionDebugResponse) UnsetEnded() {
	o.Ended.Unset()
}

// GetDuration returns the Duration field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionDebugResponse) GetDuration() string {
	if o == nil || IsNil(o.Duration.Get()) {
		var ret string
		return ret
	}
	return *o.Duration.Get()
}

// GetDurationOk returns a tuple with the Duration field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionDebugResponse) GetDurationOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Duration.Get(), o.Duration.IsSet()
}

// HasDuration returns a boolean if a field has been set.
func (o *ExtractionDebugResponse) HasDuration() bool {
	if o != nil && o.Duration.IsSet() {
		return true
	}

	return false
}

// SetDuration gets a reference to the given NullableString and assigns it to the Duration field.
func (o *ExtractionDebugResponse) SetDuration(v string) {
	o.Duration.Set(&v)
}

// SetDurationNil sets the value for Duration to be an explicit nil
func (o *ExtractionDebugResponse) SetDurationNil() {
	o.Duration.Set(nil)
}

// UnsetDuration ensures that no value is present for Duration, not even an explicit nil
func (o *ExtractionDebugResponse) UnsetDuration() {
	o.Duration.Unset()
}

// GetMemoryMb returns the MemoryMb field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionDebugResponse) GetMemoryMb() int32 {
	if o == nil || IsNil(o.MemoryMb.Get()) {
		var ret int32
		return ret
	}
	return *o.MemoryMb.Get()
}

// GetMemoryMbOk returns a tuple with the MemoryMb field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionDebugResponse) GetMemoryMbOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.MemoryMb.Get(), o.MemoryMb.IsSet()
}

// HasMemoryMb returns a boolean if a field has been set.
func (o *ExtractionDebugResponse) HasMemoryMb() bool {
	if o != nil && o.MemoryMb.IsSet() {
		return true
	}

	return false
}

// SetMemoryMb gets a reference to the given NullableInt32 and assigns it to the MemoryMb field.
func (o *ExtractionDebugResponse) SetMemoryMb(v int32) {
	o.MemoryMb.Set(&v)
}

// SetMemoryMbNil sets the value for MemoryMb to be an explicit nil
func (o *ExtractionDebugResponse) SetMemoryMbNil() {
	o.MemoryMb.Set(nil)
}

// UnsetMemoryMb ensures that no value is present for MemoryMb, not even an explicit nil
func (o *ExtractionDebugResponse) UnsetMemoryMb() {
	o.MemoryMb.Unset()
}

// GetLogs returns the Logs field value if set, zero value otherwise.
func (o *ExtractionDebugResponse) GetLogs() []interface{} {
	if o == nil || IsNil(o.Logs) {
		var ret []interface{}
		return ret
	}
	return o.Logs
}

// GetLogsOk returns a tuple with the Logs field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionDebugResponse) GetLogsOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Logs) {
		return nil, false
	}
	return o.Logs, true
}

// HasLogs returns a boolean if a field has been set.
func (o *ExtractionDebugResponse) HasLogs() bool {
	if o != nil && !IsNil(o.Logs) {
		return true
	}

	return false
}

// SetLogs gets a reference to the given []interface{} and assigns it to the Logs field.
func (o *ExtractionDebugResponse) SetLogs(v []interface{}) {
	o.Logs = v
}

// GetRowCount returns the RowCount field value if set, zero value otherwise.
func (o *ExtractionDebugResponse) GetRowCount() int32 {
	if o == nil || IsNil(o.RowCount) {
		var ret int32
		return ret
	}
	return *o.RowCount
}

// GetRowCountOk returns a tuple with the RowCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionDebugResponse) GetRowCountOk() (*int32, bool) {
	if o == nil || IsNil(o.RowCount) {
		return nil, false
	}
	return o.RowCount, true
}

// HasRowCount returns a boolean if a field has been set.
func (o *ExtractionDebugResponse) HasRowCount() bool {
	if o != nil && !IsNil(o.RowCount) {
		return true
	}

	return false
}

// SetRowCount gets a reference to the given int32 and assigns it to the RowCount field.
func (o *ExtractionDebugResponse) SetRowCount(v int32) {
	o.RowCount = &v
}

// GetBlob returns the Blob field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionDebugResponse) GetBlob() string {
	if o == nil || IsNil(o.Blob.Get()) {
		var ret string
		return ret
	}
	return *o.Blob.Get()
}

// GetBlobOk returns a tuple with the Blob field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionDebugResponse) GetBlobOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Blob.Get(), o.Blob.IsSet()
}

// HasBlob returns a boolean if a field has been set.
func (o *ExtractionDebugResponse) HasBlob() bool {
	if o != nil && o.Blob.IsSet() {
		return true
	}

	return false
}

// SetBlob gets a reference to the given NullableString and assigns it to the Blob field.
func (o *ExtractionDebugResponse) SetBlob(v string) {
	o.Blob.Set(&v)
}

// SetBlobNil sets the value for Blob to be an explicit nil
func (o *ExtractionDebugResponse) SetBlobNil() {
	o.Blob.Set(nil)
}

// UnsetBlob ensures that no value is present for Blob, not even an explicit nil
func (o *ExtractionDebugResponse) UnsetBlob() {
	o.Blob.Unset()
}

func (o ExtractionDebugResponse) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExtractionDebugResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.Message) {
		toSerialize["message"] = o.Message
	}
	if o.Started.IsSet() {
		toSerialize["started"] = o.Started.Get()
	}
	if o.Ended.IsSet() {
		toSerialize["ended"] = o.Ended.Get()
	}
	if o.Duration.IsSet() {
		toSerialize["duration"] = o.Duration.Get()
	}
	if o.MemoryMb.IsSet() {
		toSerialize["memory_mb"] = o.MemoryMb.Get()
	}
	if !IsNil(o.Logs) {
		toSerialize["logs"] = o.Logs
	}
	if !IsNil(o.RowCount) {
		toSerialize["row_count"] = o.RowCount
	}
	if o.Blob.IsSet() {
		toSerialize["blob"] = o.Blob.Get()
	}
	return toSerialize, nil
}

type NullableExtractionDebugResponse struct {
	value *ExtractionDebugResponse
	isSet bool
}

func (v NullableExtractionDebugResponse) Get() *ExtractionDebugResponse {
	return v.value
}

func (v *NullableExtractionDebugResponse) Set(val *ExtractionDebugResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableExtractionDebugResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableExtractionDebugResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExtractionDebugResponse(val *ExtractionDebugResponse) *NullableExtractionDebugResponse {
	return &NullableExtractionDebugResponse{value: val, isSet: true}
}

func (v NullableExtractionDebugResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExtractionDebugResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
